



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>[LeetCode] Candy (分糖果)，时间复杂度O(n)，空间复杂度为O(1)，且只需遍历一次的实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">[LeetCode] Candy (分糖果)，时间复杂度O(n)，空间复杂度为O(1)，且只需遍历一次的实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 19:57:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2><a href="http://www.cnblogs.com/felixfang/p/3620086.html" rel="external nofollow noreferrer">[LeetCode] Candy (分糖果)，时间复杂度O(n)，空间复杂度为O(1)，且只需遍历一次的实现</a></h2>
<div>
<div>
<p>原题：</p>
<p>There are&nbsp;<em>N</em>&nbsp;children standing in a line. Each child is assigned a rating value.</p>
<p>You are giving candies to these children subjected to the following requirements:</p>
<ul><li>Each child must have at least one candy.</li>
<li>Children with a higher rating get more candies than their neighbors.</li></ul>
<p>What is the minimum candies you must give?</p>
<h2>Solution (1)</h2>
<p>这题本身可以用贪心法来做，我们用candy[n]表示每个孩子的糖果数，遍历过程中，如果孩子i+1的rate大于孩子i 的rate，那么当前最好的选择自然是：给孩子i+1的糖果数=给孩子i的糖果数+1</p>
<p>如果孩子i+1的rate小于等于孩子i 的rate咋整？这个时候就不大好办了，因为我们不知道当前最好的选择是给孩子i+1多少糖果。</p>
<p>解决方法是：暂时不处理这种情况。等数组遍历完了，我们再一次从尾到头遍历数组，这回逆过来贪心，就可以处理之前略过的孩子。</p>
<p>最后累加candy[n]即得到最小糖果数。</p>
<p>这种解法是需要O(n)的辅助空间给candy[]的。</p>
<p>有没有更好的办法？</p>
<h2>Solution (2) 此方法以及代码部分参考了<a href="http://oj.leetcode.com/discuss/user/Shangrila" rel="external nofollow noreferrer">Shangrila</a>&nbsp;的方法。</h2>
<p>请回想一下：我们为什么需要辅助空间？当孩子的rate是一个非递减曲线的时候，我们是不需要辅助空间的，比如5个孩子的rate分别是1，2，5，7，10。那么糖果数自然是1，2，3，4，5。又如5个孩子的rate分别是1，2，5，5，10，那么糖果数自然是1，2，3，1，2。</p>
<p>因此如果rate是非递减数列，我们可以精确计算出当前孩子应该给多少糖果，把这个糖果数加入总数即可。</p>
<p>当孩子的rate出现递减的情况该如何是好？不用辅助空间能处理吗？</p>
<p>假设5个孩子的rate是 1，5，4，3，2。我们这样计算：遍历时，第一个孩子依然糖果为1，第二个孩子糖果为2，第三个孩子糖果给几个？我们遍历到后面就会知道第二个孩子给的糖果太少了，应该给4个。有没有办法在遍历到后面时，能计算出一个修正值，使得加上这个修正值，正好依然可以使总糖果数是正确的？</p>
<p>其实这个修正值不难计算，<strong>因为可以发现递减数列的长度决定了第二个孩子该给几个糖果</strong>。仔细观察：遍历到第四个孩子时我们知道了第二个孩子不该给2，应该给3，因此Total 要 +=1；遍历到第五个孩子我们知道了第二个孩子不该给3得给4，因此Total 要 += 1。我们设一个变量beforeDenc表示进入递减序列之前的那个孩子给的糖果值，再设置length用来表达当前递减序列的长度。这两个变量就可以决定Total是不是要修正：当遍历第三个孩子的时候&nbsp;beforeDenc&nbsp;= 2，以后每遍历一个孩子，因为length已经超过了beforeDenc，每次Total都要额外+1，来修正第二个孩子的糖果数。</p>
<p>对于后面三个孩子，我们可以这样计算：遍历到第三个孩子，因为这是递减数列的第二个数字，我们Total += 1；第四个孩子是递减数列的第三个数字，Total += 2；第五个孩子是递减数列的第四个数字，Total += 3。</p>
<p><strong>可以发现最后三个孩子的糖果总数依然是正确的</strong>，虽然Total 每次增加的糖果数量正好和当前孩子得到的糖果数是反序关系。</p>
<p>这种边遍历边修正的方法可以保证一次遍历，不需要O(n)空间下计算出Total的正确值。</p>
<p>代码：</p>
<div>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
<pre class="prettyprint linenums">int candy(vector&lt;int&gt; &amp;ratings) {<br />
    int Total = 0;    /// Total candies<br />
    int length = 0;  /// Continuous descending length of rate<br />
    int nPreCanCnt = 1; /// Previous child's candy count<br />
    int beforeDenc = nPreCanCnt;<br />
    if(ratings.begin() != ratings.end())<br />
    {<br />
        Total++; //Counting the first child's candy (1).<br />
        for(vector&lt;int&gt;::iterator i = ratings.begin()+1; i!= ratings.end(); i++)<br />
        {<br />
            if(*i &lt; *(i-1))<br />
            {<br />
                length++;<br />
                if(beforeDenc &lt;= length)<br />
                {<br />
                    Total++;<br />
                }<br />
                Total += length;<br />
                nPreCanCnt = 1;    //This step is important, it ensures that once we leave the decending sequence, candy number start from 1<br />
            }<br />
            else<br />
            {<br />
                int curCanCnt = 0;<br />
                if(*i &gt; *(i-1))<br />
                {<br />
                    curCanCnt = (nPreCanCnt + 1);<br />
                }<br />
                else<br />
                {<br />
                    curCanCnt = 1;<br />
                }<br />
                Total += curCanCnt;<br />
                nPreCanCnt = curCanCnt;<br />
                length = 0;    //reset length of decending sequence<br />
                beforeDenc = curCanCnt;<br />
            }<br />
        }<br />
    }<br />
    return Total;<br />
}</pre>
<div><img referrerpolicy="no-referrer"src="https://common.cnblogs.com/images/copycode.gif" /></div>
</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m963zdn9.html">C库函数使用与总结之时间函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gxnw0q.html">Bootstrap系列 -- 3&period; 段落</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q745req.html">new一个二维数组</a>
		</li>
						<li><a href="https://www.batexi.com/a/390wzw4q.html">安装ECshop普遍问题的解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjk65z9.html">POJ 3172 Scales &lpar;01背包暴力&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j02g4eq.html">lintcode &colon; 二叉树的层次遍历II</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxn6mde8.html">VB&period;Net 字符串加密类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde3g079.html">收藏一个匹配html内容的文章</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z125x39.html">2013 ACM区域赛长沙 K Pocket Cube hdu 4801</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmvj1q.html">优化MYSQL FILESORT</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vz1wn8.html">&lbrack;Android 4&period;4&period;3&rsqb; 泛泰A860 Omni4&period;4&period;3 20140610 RC2&period;0 三版通刷 by syhost</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge1gpl8.html">Java学习之国际化程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpg3o39.html">附录C--拉格朗日对偶性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjo6zj9.html">Android studio中布局文件出现render problem问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv20lky9.html">PUTTY工具的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ogrmk8.html">Python实现im2col和col2im函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjld1j9.html">电子邮件和URL输入控件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyl7vdq.html">在Mac上安装GTK（go语言GUI）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lxlwq.html">Rpgmakermv&lpar;7&rpar; Chronus&period;js说明与简要翻译</a>
		</li>
						<li><a href="https://www.batexi.com/a/9633pzj9.html">Django Aggregation聚合 django orm 求平均、去重、总和等常用方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9027374q.html">mysql 查询所有子节点的相关数据</a>
			</li>
						<li><a href="https://www.batexi.com/a/qx2w3e08.html">右键添加使用Sublime打开</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve5yrj9.html">mac osx 初次使用PHP环境搭建</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnnmx6kq.html">【SE】Week3 &colon; 四则运算式生成评分工具Extension&amp;amp&semi;Release Version&lpar;结对项目&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/953rope8.html">《Linux内核分析》第三周：Linux系统启动过程</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkg0mv8.html">Objective-C 语言特点&sol;特性</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emenlm9.html">PAT 2016 数据的交换输出</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwldk5l9.html">想转C&plus;&plus;了</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zk1g6x8.html">MongoDB高级操作&lpar;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jm01x09.html">Java实现的一个简单的模板渲染</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
